
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <signal.h>

#define BUFFERSIZE 1024

void GetConfigInfo();

char progName[] = "XVideoServer";
char confName[] = "PXNet.conf";
int xVideoServerPort;

int s;
int s2;
int fd;

void quit(int sig)
{
    close(fd);
    close(s2);
    close(s);
    exit(0);
}

main()
{
    struct sockaddr_in sin, cli;
    int icli;
    int ird;
    int iwd;
    int i, j;
    char szBuf[3000];
    //int fcnt=0;
    char fname[100];

    FILE *net_par;

    signal(SIGTERM, quit);
    GetConfigInfo();

    s = socket(AF_INET, SOCK_STREAM, 0);

    bzero(&sin, sizeof(sin));
    sin.sin_family = AF_INET;
    sin.sin_addr.s_addr = htonl(INADDR_ANY);
    sin.sin_port = htons(xVideoServerPort);

    bind(s, (struct sockaddr *) &sin, sizeof(sin));
    listen(s, 4096);

    while (1) {
	printf("SERVER: Waiting for connection ...\n");
	s2 = accept(s, (struct sockaddr *) &cli, &icli);

	printf("SERVER: Accepting socket \n");
#ifdef DEBUG
	printf("Connection is accepted\n");
	printf("IP %x.\n", ntohl(cli.sin_addr.s_addr));
	i = 1;
#endif

	bzero(fname, 100);
	sprintf(fname, "svr.m2v");
	if ((fd = open(fname, O_RDONLY | O_SYNC)) == -1) {
	    printf("Error open file (%s).\n", fname);
	    exit(1);
	}
	printf("SERVER: detected media file (%s) ..\n", fname);
	printf("SERVER: transmission cache prepared..\n");

	ird = read(fd, szBuf, 2048);
	iwd = write(s2, szBuf, ird);
	printf("SERVER: Connection is accepted from %s \n",
	       inet_ntoa(cli.sin_addr.s_addr));
	while ((ird = read(fd, szBuf, 2048)) > 0) {
	    printf(".");
	    iwd = write(s2, szBuf, ird);
#ifdef DEBUG
	    printf("Tracing %d. %d %d\n", i++, ird, iwd);
#endif
	}
	printf("\nSERVER: transmission successful. error rate=0%\n");
	close(s2);
	close(fd);
    }
    close(s);
}

void GetConfigInfo()
{
    FILE *fp;
    char *xHomeDir;
    char xVideoServerName[BUFFERSIZE];
    char buffer[BUFFERSIZE];
    int i;

    xHomeDir = getenv("XHOMEDIR");
    if (xHomeDir == NULL) {
	printf("%s : XHOMEDIR is not assigned.\n", progName);
	xHomeDir = "..";
    }

    bzero(buffer, BUFFERSIZE);
    sprintf(buffer, "%s/%s", xHomeDir, confName);
    if ((fp = fopen(buffer, "r")) < 0) {
	printf("%s : Error in open a network configuration file(%s).\n",
	       progName, buffer);
	exit(1);
    } else {
	bzero(buffer, BUFFERSIZE);

	// X Video Server
	fscanf(fp, "%s%d", xVideoServerName, &xVideoServerPort);
#ifdef DEBUG
	printf("%s : X Video Server(%s), Port(%d)\n", progName,
	       xVideoServerName, xVideoServerPort);
#endif
    }

    fclose(fp);
}
